//
//  mbm.m
//  meteor engine 1.0
//
//  Created by 영호 천 on 09. 06. 05.
//  Copyright 2009 ... All rights reserved.
//

#pragma once

#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#include "me_math.h"
#include "me_Texture.h"
#include "me_Common.h"

struct me_SXBMHeader
{
	char ID[4];
	unsigned char Version;
};

struct me_SXBMVertex
{
	float x, y, z;
};

struct me_SXBMTexcoord
{
	float u,v;
};

struct me_SXBMFace
{
	int p1,p2,p3;
} ;

struct me_SXBM_Vertex
{	
	float Vertex[4];
	float uv[2];		
} ;


struct me_SXBMObject
{
	char Name[80];

	int nVertex;
	float *Vertex;	
	float *Texcoord;
	
	int nFace;
	unsigned short *Face;

	me_STexture Texture;
	char TexName[256];
} ;

class me_CXBM
{
protected:
	me_SXBMHeader Header;

	unsigned char nObject;
	me_SXBMObject *Object;	

	int nFrame;
	
public:
	void Render(int cur_frame=0);	
	
	void Load(const char *filename);	
	void LoadObject(const char* filename);
	
	me_CXBM();
	~me_CXBM();
};	