#import "me_box2d.h"
#import <OpenGLES/EAGL.h>

#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import <OpenGLES/ES2/gl.h>
#import <OpenGLES/ES2/glext.h>

me_CBox2D g_Box2D;

me_CBox2D::me_CBox2D()
{
	m_World = NULL;
}

me_CBox2D::~me_CBox2D()
{
	Clear();
}

void me_CBox2D::Clear()
{
	delete m_World;
	m_World=NULL;
}

void me_CBox2D::Init()
{
	b2Vec2 gravity(0.0f, 98.0f);	
	bool doSleep = true;
	m_World = new b2World(gravity, doSleep);
	
	b2BodyDef groundBodyDef;
	groundBodyDef.position.Set(160.0f, 400.0f);
	b2Body *g_GroundBody = m_World->CreateBody(&groundBodyDef);
	b2PolygonShape groundBox;
	groundBox.SetAsBox(160.0f, 10.0f);
	g_GroundBody->CreateFixture(&groundBox, 0);
	
	groundBodyDef.position.Set(0.0f, 240.0f);
	g_GroundBody = m_World->CreateBody(&groundBodyDef);
	groundBox.SetAsBox(10.0f, 240.0f);
	g_GroundBody->CreateFixture(&groundBox, 0);
	
	groundBodyDef;
	groundBodyDef.position.Set(320.0f, 240.0f);
	g_GroundBody = m_World->CreateBody(&groundBodyDef);	
	groundBox.SetAsBox(10.0f, 240.0f);
	g_GroundBody->CreateFixture(&groundBox, 0);
}

void me_CBox2D::CreateBox(float x, float y, float hx, float hy)
{
	int i;
	for(i=0;i<MAX_BODY;i++)
	{
		if(m_Body[i].Type != ME_BOX2D_TYPE_NONE) continue;
		
		m_Body[i].Type = ME_BOX2D_TYPE_BOX;
		m_Body[i].hx = hx;
		m_Body[i].hy = hy;
		
		b2BodyDef bodyDef;
		bodyDef.type = b2_dynamicBody;
		bodyDef.position.Set(x, y);	
		bodyDef.angle = (rand()%90)*0.01745329f;
		bodyDef.angularDamping = 0.02f;
		m_Body[i].body = m_World->CreateBody(&bodyDef);
		
		b2PolygonShape dynamicBox;	
		dynamicBox.SetAsBox(hx, hy);
		
		b2FixtureDef fixtureDef;
		fixtureDef.shape = &dynamicBox;
		fixtureDef.density = 20.0f;
		fixtureDef.friction = 0.1f;
		
		m_Body[i].body->CreateFixture(&fixtureDef);		
		//m_Body[i].body->SetMassFromShapes();
		break;
	}
}

void me_CBox2D::FrameMove()
{
	m_World->Step(1.0f/60.0f, 10, 10);
    m_World->ClearForces();
}


void me_CBox2D::DrawBox(float x, float y, float angle, float hx, float hy)
{
	GLfloat vertex[8] =
	{
		-hx,	-hy,
		hx,		-hy,
		-hx,	hy,
		hx,		hy
	};
	
	glPushMatrix();
	glTranslatef(x, y, 0);
	glRotatef(angle, 0, 0, 1);
	
	glVertexPointer(2, GL_FLOAT, 0, vertex);
	glEnableClientState(GL_VERTEX_ARRAY);
	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);	
	
	glPopMatrix();
}

void me_CBox2D::Render()
{
	int i;
	for(i=0;i<MAX_BODY;i++)
	{
		if(m_Body[i].Type == ME_BOX2D_TYPE_NONE) continue;
		
		b2Vec2 position = m_Body[i].body->GetPosition();
		float32 angle = m_Body[i].body->GetAngle();	
		DrawBox(position.x, position.y, angle*57.29577951f, m_Body[i].hx, m_Body[i].hy);
	}
}