#pragma once

#import "Box2D.h"
#import "me_Texture.h"

#define MAX_BODY 256

enum 
{
	ME_BOX2D_TYPE_NONE,
	ME_BOX2D_TYPE_BOX,
	ME_BOX2D_TYPE_CIRCLE,
};

struct me_SBody
{
	int Type;
	float x, y;
	float hx, hy;
	float radius;
	b2Body *body;
	
	me_STexture tex;
	
	me_SBody()
	{
		Type = ME_BOX2D_TYPE_NONE;
	}
};

class me_CBox2D
{
protected:
	b2World *m_World;
	
	me_SBody m_Body[MAX_BODY];
	
public:
	me_CBox2D();
	~me_CBox2D();
	
	void Init();
	void Clear();
	void CreateBox(float x, float y, float hx, float hy, const char *texname, float density);
	void CreateCircle(float x, float y, float radius, const char *texname, float density);
	
	void DrawBox(float x, float y, float angle, float hx, float hy, me_STexture tex);
	
	void SetForce(int Index, float fx, float fy);
	
	me_SBody *GetBody(int Index);
	
	void Render();
	void FrameMove();
};

extern me_CBox2D g_Box2D;