#import "game_car.h"
#import "me_Sprite.h"

#define MAX_ENEMYCAR 32
SCar g_PlayerCar, g_EnemyCar[MAX_ENEMYCAR];
me_STexture g_PlayerTex, g_EnemyTex;
int g_EnemyTimeInterval=0;

void Car_Init()
{
	g_PlayerTex = me_CreateTexture(@"car_player.png");
	g_EnemyTex = me_CreateTexture(@"car_enemy.png");
	
	g_PlayerCar.x=128;
	g_PlayerCar.y=400;
}

void Car_AddEnemy()
{
	int i;
	for(i=0;i<MAX_ENEMYCAR;i++)
	{
		if(g_EnemyCar[i].Type == CT_NONE)
		{
			g_EnemyCar[i].x = (rand()%6) * 53;
			g_EnemyCar[i].y = -100;
			g_EnemyCar[i].Type = CT_ENEMY;
			
			break;
		}
	}
}

int isCollide(float box1_x1, float box1_y1, float box1_x2, float box1_y2,
			  float box2_x1, float box2_y1, float box2_x2, float box2_y2)
{
	if(box1_x1 < box2_x2 &&
	   box1_y1 < box2_y2 &&
	   box1_x2 > box2_x1 &&
	   box1_y2 > box2_y1)
	{
		return 1;
	}
	
	return 0;
}

int Car_FrameMove()
{
	int Crush = 0;
	
	int i;
	for(i=0;i<MAX_ENEMYCAR;i++)
	{
		if(g_EnemyCar[i].Type == CT_NONE) continue;
		
		g_EnemyCar[i].y+=2;
		
		if(isCollide(g_PlayerCar.x + 10, g_PlayerCar.y + 6, g_PlayerCar.x + 54, g_PlayerCar.y + 58,
					 g_EnemyCar[i].x + 10, g_EnemyCar[i].y + 6, g_EnemyCar[i].x + 54, g_EnemyCar[i].y + 58))
		{
			Crush = 1;
		}
		
		if(g_EnemyCar[i].y>480) 
		{
			g_EnemyCar[i].Type = CT_NONE;
		}
	}
	
	g_EnemyTimeInterval++;
	if(g_EnemyTimeInterval>=60)
	{
		g_EnemyTimeInterval = 0;
		Car_AddEnemy();
	}
	
	return Crush;
}

void Car_Render()
{
	int i;
	for(i=0;i<MAX_ENEMYCAR;i++)
	{
		if(g_EnemyCar[i].Type == CT_NONE) continue;
		
		me_PutSpr(g_EnemyCar[i].x, g_EnemyCar[i].y, g_EnemyTex);
	}
	
	me_PutSpr(g_PlayerCar.x, g_PlayerCar.y, g_PlayerTex);
}