#import "me_Sound.h"

const char *me_GetBundlePath(const char *s, const char *directory)
{
	NSString *dir = nil;
	if (directory)
		dir = [[NSString alloc] initWithUTF8String: directory];
	NSString *name = [[NSString alloc] initWithUTF8String: s];
	NSString *path = [[NSBundle mainBundle] pathForResource:name ofType:nil inDirectory:dir];
	
	return [path UTF8String];
	
}

SystemSoundID me_CreateSound(const char *filename)
{
	SystemSoundID sID;
	
	const char *path = me_GetBundlePath(filename, 0);
	NSString *dir = [[NSString alloc] initWithUTF8String: path];
	
	CFURLRef sndURL = (CFURLRef)[[NSURL alloc] initFileURLWithPath:dir];
	AudioServicesCreateSystemSoundID(sndURL, &sID);	
	
	return sID;	
}

void me_PlaySound(SystemSoundID sID)
{
	AudioServicesPlaySystemSound(sID);
}

void me_DeleteSound(SystemSoundID sID)
{
	AudioServicesDisposeSystemSoundID(sID);
}