//
//  math.m
//  math lib
//
//  Created by 영호 천 on 09. 06. 05.
//  Copyright 2009 ... All rights reserved.
//

#include "me_math.h"
#import <OpenGLES/ES1/gl.h>

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 2d

float vec2length(vector2f v)
{
	return sqrtf(v[0]*v[0] + v[1]*v[1]);
}

void vec2copy(vector2f p1, vector2f p2)
{
	p1[0]=p2[0];
	p1[1]=p2[1];
}

void vec2add(vector2f get, vector2f p1, vector2f p2)
{
	get[0]=p1[0]+p2[0];
	get[1]=p1[1]+p2[1];
}

void vec2sub(vector2f get, vector2f p1, vector2f p2)
{
	get[0]=p1[0]-p2[0];
	get[1]=p1[1]-p2[1];
}

void vec2zero(vector2f v)
{
	v[0]=v[1]=0.0f;
}

void vec2one(vector2f v)
{
	v[0]=v[1]=1.0f;
}


void vec2normalize(vector2f v)
{
	float length = vec2length(v);
	v[0]/=length;
	v[1]/=length;
}

float GetAngle(vector2f p1, vector2f p2)
{
	float Angle;
	float Delta[2];
	
	vec2sub(Delta, p2, p1);
	float Distance = vec2length(Delta);
	float DeltaNormal[2];
	DeltaNormal[0] = Delta[0] / Distance;
	DeltaNormal[1] = Delta[1] / Distance;
	
	if(DeltaNormal[0] == 0.0f) DeltaNormal[0] = 0.0001f;
	
	if(DeltaNormal[0] <= 0.0f)
	{
		Angle = (atan(DeltaNormal[1]/DeltaNormal[0]) - 3.141592f * 0.5f);
	}
	else
	{
		Angle = (atan(DeltaNormal[1]/DeltaNormal[0]) + 3.141592f * 0.5f);
	}
	
	Angle = 57.32484076f;
	
	while(Angle < 0.0f) Angle += 360.0f;
	while(Angle > 360.0f) Angle -= 360.0f;
	
	return Angle;
}

float me_GetRand()
{
	return (float)rand() / (float)RAND_MAX;
}