#pragma once

//#import <Cocoa/Cocoa.h>
#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#import "me_math.h"
#import "me_Texture.h"

enum 
{
	ME_GT_NONE,
	ME_GT_IMAGE,
	ME_GT_BUTTON,
	ME_GT_LISTBOX
};

class me_CGUI_Control
{
public:
	int Type;
	vector2f Pos;
	me_STexture Tex;
	
	virtual void Render()=0;
};

class me_CGUI_Image : public me_CGUI_Control
{
public:
	me_CGUI_Image(float x, float y, char *TexName);
	
	void Render();
};

class me_CGUI_Button : public me_CGUI_Control
{
protected:
	char Command[64];
	
public:
	me_CGUI_Button(float x, float y, char *TexName, char *cmb);
	
	void Render();
	
	char *Check(float x, float y);
};


#define MAX_LISTBOXITEM 32
class me_CGUI_Listbox : public me_CGUI_Control
{
protected:
	float Width, Height;
	
	char Command[64];
	char ReturnText[64];
	
	int ItemCount;
	me_STexture Item[MAX_LISTBOXITEM];
	
public:
	me_CGUI_Listbox(float x, float y, float width, float height, char *cmb);
	void AddItem(char *item);
	
	void Render();
	
	char *Check(float x, float y);
	
	void ClearItem();
};

#define MAX_SCENECONTROL 8
class me_CGUI_Scene
{
protected:
	me_CGUI_Control *m_Control[MAX_SCENECONTROL];
	char m_LastCommand[256];
	
public:
	void Load(const char *filename);
	void Clear();
	
	void AddControl(me_CGUI_Control *control);
	
	void Render();
		
	char *TouchEnd(float x, float y);
	int CommandAnalyze(char *Text);
	
	me_CGUI_Scene();
	~me_CGUI_Scene();
};