//
//  Texture.m
//  SkyAtWar
//
//  Created by 영호 천 on 09. 06. 05.
//  Copyright 2009 ... All rights reserved.
//

#import "me_Texture.h"

me_STexture me_CreateTexture(char *filename)
{
	return me_CreateTexture([[NSString alloc] initWithUTF8String: filename]);
}

me_STexture me_CreateTexture(NSString *filename)
{
	CGImageRef spriteImage;
	CGContextRef spriteContext;
	GLubyte *spriteData;
	
	me_STexture tTex;
	
	spriteImage = [UIImage imageNamed:filename].CGImage;
	
	tTex.Width = CGImageGetWidth(spriteImage);
	tTex.Height = CGImageGetHeight(spriteImage);
		
	if(spriteImage) 
	{
		spriteData = (GLubyte *) malloc(tTex.Width * tTex.Height * 4);
		memset(spriteData, 0, tTex.Width * tTex.Height * 4);
		spriteContext = CGBitmapContextCreate(spriteData, tTex.Width, tTex.Height, 8, tTex.Width * 4, 
											  CGImageGetColorSpace(spriteImage), kCGImageAlphaPremultipliedLast	);
		CGContextDrawImage(spriteContext, CGRectMake(0.0, 0.0, (CGFloat)tTex.Width, (CGFloat)tTex.Height), spriteImage);
		CGContextRelease(spriteContext);
		
		glGenTextures(1, &tTex.TexID);
		glBindTexture(GL_TEXTURE_2D, tTex.TexID);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tTex.Width, tTex.Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, spriteData);
		free(spriteData);
		
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		
		glEnable(GL_TEXTURE_2D);
	}
	
	return tTex;
}

void me_DeleteTexture(me_STexture Texture)
{
	if(Texture.TexID!=0)
		glDeleteTextures(1, &Texture.TexID);
}