#import "me_Sound.h"

const char *me_GetBundlePath(const char *s, const char *directory)
{
	NSString *dir = nil;
	if (directory)
		dir = [[NSString alloc] initWithUTF8String: directory];
	NSString *name = [[NSString alloc] initWithUTF8String: s];
	NSString *path = [[NSBundle mainBundle] pathForResource:name ofType:nil inDirectory:dir];
	
	return [path UTF8String];
	
}

SystemSoundID me_CreateSound(const char *filename)
{
	SystemSoundID sID;
	
	const char *path = me_GetBundlePath(filename, 0);
	NSString *dir = [[NSString alloc] initWithUTF8String: path];
	
	CFURLRef sndURL = (CFURLRef)[[NSURL alloc] initFileURLWithPath:dir];
	AudioServicesCreateSystemSoundID(sndURL, &sID);	
	
	return sID;	
}

void me_PlaySound(SystemSoundID sID)
{
	AudioServicesPlaySystemSound(sID);
}

void me_DeleteSound(SystemSoundID sID)
{
	AudioServicesDisposeSystemSoundID(sID);
}


AVAudioPlayer *g_AudioPlayer=nil;
void me_SetBGM(NSString *name, NSString *type)
{
	NSString *soundFilePath=[[NSBundle mainBundle] pathForResource:name ofType:type];
	NSURL *fileURL=[[NSURL alloc] initFileURLWithPath:soundFilePath];
	g_AudioPlayer=[[AVAudioPlayer alloc] initWithContentsOfURL:fileURL error:nil];
	[fileURL release];
}

void me_SetVolumeBGM(float volume)
{
	if(g_AudioPlayer!=nil)
		g_AudioPlayer.volume = volume;
}

void me_SetLoopBGM(int loops)
{
	if(g_AudioPlayer!=nil)
		g_AudioPlayer.numberOfLoops = loops;
}

void me_PlayBGM()
{
	if(g_AudioPlayer!=nil)
	{
		[g_AudioPlayer prepareToPlay];
		[g_AudioPlayer play];
	}
}

void me_StopBGM()
{
	if(g_AudioPlayer!=nil)
		[g_AudioPlayer stop];
}

void me_PauseBGM()
{
	if(g_AudioPlayer!=nil)
		[g_AudioPlayer pause];
}

int me_PlayingBGM()
{
	if(g_AudioPlayer==nil) return 0;
	
	return g_AudioPlayer.playing;
}

void me_DeleteBGM()
{
	if(g_AudioPlayer!=nil)
		[g_AudioPlayer release];
}

AVAudioPlayer *me_GetBGM()
{
	return g_AudioPlayer;
}