#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#import "game_neon.h"

enum 
{
	BT_NORMAL,
	BT_ENEMY,
	BT_MAX
};

#define MAX_BULLET 128
struct SBullet
{
	int Type;
	vector2f Pos;
	vector2f Delta;
	float Angle;
	
	float Speed;
	float Life;
		
	SBullet()
	{
		Type = BT_NORMAL;
		Life = 0.0f;
	}
};
	
	
class CBullet
{
protected:
	SBullet m_Bullet[MAX_BULLET];
	
	CNeon m_Neon[BT_MAX];
	
public:
	void Init();
	
	void Create(vector2f Pos, float Angle, float Speed, int Type);
	
	void Save(FILE *fp);
	void Load(FILE *fp);
	
	void FrameMove();
	void Render();
};

extern CBullet g_Bullet;