#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#import "game_Neon.h"
#import "game_Pattern.h"

enum 
{
	ET_NONE,
	ET_ARROW,
	ET_OCTAGON,
	ET_CORE,
	ET_MAX
};

struct SEnemy
{
	int Type;
	vector2f Pos;
	float Angle;
	
	int PatternIdx;
	
	vector2f TargetDelta;
	float MoveTime;
	
	float FireDelay;
	
	SEnemy()
	{
		Type = ET_NONE;
		MoveTime = 0.0f;
		
		FireDelay = 0.0f;
	}
};


#define MAX_ENEMY 128
class CEnemy
{
protected:
	SEnemy m_Enemy[MAX_ENEMY];
	
	CNeon m_Neon[ET_MAX];
	CPattern m_Pattern[ET_MAX];
	
public:
	void Init();
	
	void FrameMove();
	void Render();
	
	int CheckBullet(vector2f bPos);
	
	void Create(float x, float y, int Type);
	
	void Save(FILE *fp);
	void Load(FILE *fp);
	
	CEnemy();
	~CEnemy();
};

extern CEnemy g_Enemy;