#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#import "me_math.h"
#import "me_Common.h"
 
#define MAX_NEONVERTEXLIST 128
class CNeon
{
protected:
	int nVertexList;
	vector2f VertexList[MAX_NEONVERTEXLIST];
	vector3f NormalList[MAX_NEONVERTEXLIST];
	
	// 렌더링 구조체
	vector2f rVL[MAX_NEONVERTEXLIST * 3];
	vector2f rTL[MAX_NEONVERTEXLIST * 3];
	
	vector4f m_Color;
	
public:
	void Save(const char *filename);
	void Load(const char *filename);
	
	void Render(GLuint TexID=0);
	
	void Scale(float Scale);
	
	void Collide(vector2f Pos, float Radius);
	
	void MakeRenderData();
	
	void SetColor(vector4f Color) { vec4copy(m_Color, Color); }
	void GetColor(vector4f Color) { vec4copy(Color, m_Color); }
	
	CNeon();
	~CNeon();
};