#import "game_Pattern.h"
#import "me_Common.h"
#import "me_timer.h"

CPattern::CPattern()
{
	m_PatternNum=0;
}

CPattern::~CPattern()
{
}

SPattern *CPattern::GetPattern(int &PatternIdx)
{
	if(PatternIdx >= m_PatternNum) return NULL;
	
	SPattern *rPattern = &m_Pattern[PatternIdx];
	
	if(PatternIdx < m_PatternNum)
	{
		PatternIdx ++;
	}
	
	if(rPattern->Command==EP_RESET) PatternIdx = 0;
	
	return rPattern;
}

int CPattern::Load(const char *filename)
{
	const char *path = me_GetBundlePath(filename, 0);
	FILE *fp;
	fp = fopen(path, "rt");
	if(fp==NULL)
	{
		NSLog(@"CPattern::Load fail.");
		return NO;
	}
	
	m_PatternNum=0;
	
	char Text[256];
	while(!feof(fp))
	{
		fscanf(fp, "%s", Text);
		
		if(!strcmp(Text, "lookplayer"))
		{
			m_Pattern[m_PatternNum].Command = EP_LOOKPLAYER;
			fscanf(fp, "%f", &m_Pattern[m_PatternNum].Value[0]);
			m_PatternNum++;
			continue;
		}
		
		if(!strcmp(Text, "moveforward"))
		{
			m_Pattern[m_PatternNum].Command = EP_MOVEFORWARD;
			fscanf(fp, "%f"	, &m_Pattern[m_PatternNum].Value[0]);
			m_PatternNum++;
			continue;
		}
		
		if(!strcmp(Text, "randommove"))
		{
			m_Pattern[m_PatternNum].Command = EP_RANDOMMOVE;
			fscanf(fp, "%f"	, &m_Pattern[m_PatternNum].Value[0]);
			m_PatternNum++;
			continue;
		}
		
		if(!strcmp(Text, "fire"))
		{
			m_Pattern[m_PatternNum].Command = EP_FIRE;
			fscanf(fp, "%f %f"	, &m_Pattern[m_PatternNum].Value[0], &m_Pattern[m_PatternNum].Value[1]);
			m_PatternNum++;
		}
		
		if(!strcmp(Text, "reset"))
		{
			m_Pattern[m_PatternNum].Command = EP_RESET;
			m_PatternNum++;
			continue;
		}
	}
	
	fclose(fp);	
	
	return YES;
}