#import "game_Respawn.h"
#import "me_Common.h"
#import "me_timer.h"
#import "game_Enemy.h"

CRespawnPattern g_RespawnPattern;

CRespawnPattern::CRespawnPattern()
{
	m_PatternIdx=0;
	m_DelayTime=0.0f;
}

CRespawnPattern::~CRespawnPattern()
{
}

void CRespawnPattern::Process()
{
	if(m_DelayTime > 0) 
	{
		m_DelayTime -= me_GetElapsedTime();
		return;
	}
	
	switch(m_Pattern[m_PatternIdx].Command)
	{
		case RP_CREATE:
			{
				float x = m_Pattern[m_PatternIdx].Value[0];
				float y = m_Pattern[m_PatternIdx].Value[1];
				int type = m_Pattern[m_PatternIdx].Value[2];
				int count = m_Pattern[m_PatternIdx].Value[3];
				
				int i;
				for(i=0;i<count;i++)
				{
					g_Enemy.Create(x, y, type);
				}
			}
			break;
			
		case RP_DELAY:
			m_DelayTime = m_Pattern[m_PatternIdx].Value[0];
			break;
	}
	
	if(m_PatternIdx < MAX_RESPAWNPATTERN-1)
	{
		m_PatternIdx++;
	}
}

int CRespawnPattern::Load(const char *filename)
{
	const char *path = me_GetBundlePath(filename, 0);
	FILE *fp;
	fp = fopen(path, "rt");
	if(fp==NULL)
	{
		NSLog(@"CRespawnPattern::Load fail.");
		return NO;
	}
	
	m_PatternNum=0;
	m_PatternIdx=0;
	
	char Text[256];
	while(!feof(fp))
	{
		fscanf(fp, "%s", Text);
		
		if(!strcmp(Text, "create"))
		{
			m_Pattern[m_PatternNum].Command = RP_CREATE;
			fscanf(fp, "%f %f %f %f", &m_Pattern[m_PatternNum].Value[0]
									, &m_Pattern[m_PatternNum].Value[1]
									, &m_Pattern[m_PatternNum].Value[2]
									, &m_Pattern[m_PatternNum].Value[3]);
			m_PatternNum++;
			continue;
		}
		
		if(!strcmp(Text, "delay"))
		{
			m_Pattern[m_PatternNum].Command = RP_DELAY;
			fscanf(fp, "%f"	, &m_Pattern[m_PatternNum].Value[0]);
			m_PatternNum++;
			continue;
		}
	}
	
	fclose(fp);	
	
	return YES;
}