#import "game_common.h"
#import "game_bg.h"
#import "me_Sprite.h"

CBG g_BG;

CBG::CBG()
{
}

CBG::~CBG()
{
}

void CBG::Init()
{
	m_BGNeon.Load("bg.neon");
	m_BGNeon.Scale(3.0f);
	vector4f Color = {0.9019f, 0.8078f, 0.0235f, 1.0f};
	m_BGNeon.SetColor(Color);
	
	m_BGTex = me_CreateTexture(@"bg.png");
	
	int i, j;
	for(i=0;i<32;i++)
	{
		for(j=0;j<38;j++)
		{
			m_GridPointList[i][j][0] = i*50 - 800;
			m_GridPointList[i][j][1] = j*50 - 950;
		}
	}
}

void CBG::Collide(vector2f Pos)
{
	m_BGNeon.Collide(Pos, 16);
}

void CBG::RenderBefore()
{
	glDisable(GL_BLEND);
	glColor4f(0.3f, 0.3f, 0.3f, 1.0f);
	me_PutSpr(240-256, 160-256, m_BGTex);
	glEnable(GL_BLEND);
}

void CBG::RenderAfter()
{
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	
	glColor4f(0,0,1,1);
	glVertexPointer(2, GL_FLOAT, 0, m_GridPointList);
	glDrawArrays(GL_POINTS, 0, 32*38);
	
	glEnable(GL_TEXTURE_2D);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);

	glColor4f(1, 1, 1, 1);
	glEnable(GL_BLEND);
	
	m_BGNeon.Render(g_NeonLineTex.TexID);
}