#import "game_common.h"
#import "game_player.h"
#import "game_Bullet.h"
#import "me_ScreenPad.h"
#import "me_Timer.h"

CPlayer g_Player;

CPlayer::CPlayer()
{
}

CPlayer::~CPlayer()
{
}

void CPlayer::Init()
{
	g_ScreenPad.Init();
	m_SPMoveIdx = g_ScreenPad.AddPad(MEPT_ANALOG, 0, 192);
	m_SPShootIdx = g_ScreenPad.AddPad(MEPT_ANALOG, 352, 192);

	m_Pos[0]=0;
	m_Pos[1]=0;
	
	m_Angle = 0;
	
	m_FireDelay = 0;
	
	m_Neon.Load("Player.neon");
	vector4f color = {0.2039f, 0.4745f, 0.8078f, 1.0f};
	m_Neon.SetColor(color);
	
}

void CPlayer::FrameMove()
{
	me_SScreenPad PadInfo=g_ScreenPad.GetPadInfo(m_SPMoveIdx);
	if(PadInfo.isOn)
	{
		m_Pos[0] += PadInfo.Delta[0] * 3.0f;
		m_Pos[1] += PadInfo.Delta[1] * 3.0f;
	}
	
	PadInfo=g_ScreenPad.GetPadInfo(m_SPShootIdx);
	if(PadInfo.isOn)
	{
		m_Angle = PadInfo.Angle;
		
		if(m_FireDelay>0) 
		{
			m_FireDelay -= me_GetElapsedTime();
		}
		else
		{
			g_Bullet.Create(m_Pos, m_Angle, 15, BT_NORMAL);	
			m_FireDelay = 0.1f;
		}

		
	}
}


int CPlayer::CheckBullet(vector2f bPos)
{
	vector2f delta;
	float Length;
	
	vec2sub(delta, m_Pos, bPos);
	Length = vec2length(delta);
	
	if(Length <= 17 )
	{
		return 1;
	}
	
	return 0;
}


void CPlayer::Render()
{
	glPushMatrix();
	
	glTranslatef(m_Pos[0], m_Pos[1], 0);
	glRotatef(m_Angle, 0, 0, 1);
	m_Neon.Render(g_NeonLineTex.TexID);
	
	glPopMatrix();
}


void CPlayer::Save(FILE *fp)
{
	fwrite(m_Pos, sizeof(vector2f), 1, fp);
	fwrite(&m_Angle, sizeof(float), 1, fp);
	fwrite(&m_FireDelay, sizeof(float), 1, fp);
}

void CPlayer::Load(FILE *fp)
{
	fread(m_Pos, sizeof(vector2f), 1, fp);
	fread(&m_Angle, sizeof(float), 1, fp);
	fread(&m_FireDelay, sizeof(float), 1, fp);
}