//
//  OpenFeintExAppDelegate.m
//  OpenFeintEx
//
//  Created by 영호 천 on 10. 12. 2..
//  Copyright 2010 .. All rights reserved.
//

#import "OpenFeintExAppDelegate.h"
#import "OpenFeintExViewController.h"

#import "OpenFeint.h"

@implementation OpenFeintExAppDelegate

@synthesize window;
@synthesize viewController;


#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
    // Override point for customization after application launch.

    // Add the view controller's view to the window and display.
    [window addSubview:viewController.view];
    [window makeKeyAndVisible];
	
	NSDictionary* settings = [NSDictionary dictionaryWithObjectsAndKeys:
							  [NSNumber numberWithInt:UIInterfaceOrientationLandscapeRight], OpenFeintSettingDashboardOrientation,
							  [NSNumber numberWithInt:ENotificationPosition_BOTTOM], OpenFeintSettingNotificationPosition,
							  nil];
	
	// 오픈페인트 개발자 페이지에서 어플리케이션을 등록하고 프로덕트 키와 시크릿을 입력하여 주세요.
	[OpenFeint initializeWithProductKey:@"xxxxxxx" andSecret:@"Sp2VE7cEV95uLImyWtVZube3XSVP519JmLg7jJ8w" 
						 andDisplayName:@"xxxxx" andSettings:settings andDelegates:nil];

    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
	[OpenFeint applicationWillResignActive];
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
	[OpenFeint applicationDidBecomeActive];
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
	
	[OpenFeint shutdown];
}


- (void)dealloc {
    [viewController release];
    [window release];
    [super dealloc];
}


@end
