#import "game_Respawn.h"
#import "me_Common.h"
#import "me_timer.h"
#import "game_Enemy.h"

CRespawnPattern g_RespawnPattern;

CRespawnPattern::CRespawnPattern()
{
	m_PatternIdx=0;
	m_WaitTime = 0;
	m_HPMulti = 1.0f;
}

CRespawnPattern::~CRespawnPattern()
{
}

void CRespawnPattern::Process()
{
	if(g_Enemy.Empty()==0) return;
	
	int Flag = 1;
	
	while(Flag)
	{
		switch(m_Pattern[m_PatternIdx].Command)
		{
			case RP_CREATE:
				{
					int Type = m_Pattern[m_PatternIdx].Value[0];
					int HP = m_Pattern[m_PatternIdx].Value[1]*m_HPMulti;
					float Speed = m_Pattern[m_PatternIdx].Value[2];
					int count = m_Pattern[m_PatternIdx].Value[3];
				
					int i;
					for(i=0;i<count;i++)
					{
						g_Enemy.Create(Type, HP, Speed, m_WaitTime);
						m_WaitTime += 1.0f;
					}
				}
				break;
			
			case RP_PHASEEND:
				m_WaitTime = 0.0f;
				Flag = 0;
				break;
		}
		
		m_PatternIdx++;
		if(m_PatternIdx>=MAX_RESPAWNPATTERN-1) 
		{
			m_PatternIdx = 0;
			m_HPMulti += 0.2f;
		}
	}	
}

int CRespawnPattern::Load(const char *filename)
{
	const char *path = me_GetBundlePath(filename, 0);
	FILE *fp;
	fp = fopen(path, "rt");
	if(fp==NULL)
	{
		NSLog(@"CRespawnPattern::Load fail.");
		return NO;
	}
	
	m_PatternNum=0;
	m_PatternIdx=0;
	
	char Text[256];
	while(!feof(fp))
	{
		fscanf(fp, "%s", Text);
		
		if(!strcmp(Text, "create"))
		{
			m_Pattern[m_PatternNum].Command = RP_CREATE;
			fscanf(fp, "%f %f %f %f", &m_Pattern[m_PatternNum].Value[0]
									, &m_Pattern[m_PatternNum].Value[1]
									, &m_Pattern[m_PatternNum].Value[2]
									, &m_Pattern[m_PatternNum].Value[3]);
			m_PatternNum++;
			continue;
		}
		
		if(!strcmp(Text, "phaseend"))
		{
			m_Pattern[m_PatternNum].Command = RP_PHASEEND;
			m_PatternNum++;
			continue;
		}
	}
	
	fclose(fp);	
	
	return YES;
}