#import "game_bullet.h"
#import "game_enemy.h"

CBullet g_Bullet;

void CBullet::Init()
{
	m_BulletTex[BT_PLASMA]=me_CreateTexture(@"bullet_plasma.png");
	m_BulletTex[BT_MISSILE]=me_CreateTexture(@"bullet_missile.png");
}

void CBullet::FrameMove()
{
	int i;
	SEnemy *tEnemy;
	vector2f delta;
	float angle;
	float angledelta;
	float rad;
	
	for(i=0;i<MAX_BULLET;i++)
	{
		if(m_Bullet[i].Type == BT_NONE) continue;
		
		tEnemy = g_Enemy.GetEnemy(m_Bullet[i].TargetIndex);
		
		angle = GetAngle(m_Bullet[i].Pos, tEnemy->Pos);
		if(angle >= 360) angle -= 360.0f;
		if(angle < 0) angle += 360.0f;
		
		angledelta = fabsf( m_Bullet[i].Angle- angle);
		if(angledelta<=5) m_Bullet[i].Angle = angle;
		else 
		{
			if( angledelta >= 180)
			{
				if(m_Bullet[i].Angle > angle) m_Bullet[i].Angle += 5;
				if(m_Bullet[i].Angle < angle) m_Bullet[i].Angle -= 5;
			}
			else 
			{
				if(m_Bullet[i].Angle > angle) m_Bullet[i].Angle -= 5;
				if(m_Bullet[i].Angle < angle) m_Bullet[i].Angle += 5;
			}

		}
		
		if(m_Bullet[i].Angle >= 360) m_Bullet[i].Angle -= 360.0f;
		if(m_Bullet[i].Angle < 0) m_Bullet[i].Angle += 360.0f;

		rad = DEGREE2RAD(m_Bullet[i].Angle);
		m_Bullet[i].Pos[0] += +4.0f * sin(rad);
		m_Bullet[i].Pos[1] += -4.0f * cos(rad);
		
		vec2sub(delta, m_Bullet[i].Pos, tEnemy->Pos);
		if(vec2length(delta)<4.0f)
		{
			tEnemy->HP-=m_Bullet[i].Pow;
			//if(tEnemy->HP<=0) 
			//{
			//	tEnemy->Type = ET_NONE;
			//}
			
			if(m_Bullet[i].Type == BT_MISSILE)
			{
				g_Enemy.SplashDamage(m_Bullet[i].Pos, 64, 
									 m_Bullet[i].Pow/3.0f,
									 m_Bullet[i].TargetIndex);
			}
			
			m_Bullet[i].Type = BT_NONE;
		}
	}
}

void CBullet::Render()
{
	int i;
	for(i=0;i<MAX_BULLET;i++)
	{
		if(m_Bullet[i].Type == BT_NONE) continue;
		if(m_Bullet[i].Type == BT_GUN) continue;
		
		me_PutSpr(m_Bullet[i].Pos[0]-m_BulletTex[m_Bullet[i].Type].Width/2, 
				  m_Bullet[i].Pos[1]-m_BulletTex[m_Bullet[i].Type].Height/2, 
				  m_BulletTex[m_Bullet[i].Type], m_Bullet[i].Angle);
	}
}

void CBullet::Create(float x, float y, int Type, int TargetIndex, float Angle, int Pow)
{
	int i;
	for(i=0;i<MAX_BULLET;i++)
	{
		if(m_Bullet[i].Type == BT_NONE)
		{
			m_Bullet[i].Pos[0]=x;
			m_Bullet[i].Pos[1]=y;
			m_Bullet[i].Type = Type;
			m_Bullet[i].TargetIndex = TargetIndex;
			m_Bullet[i].Angle = Angle;
			m_Bullet[i].Pow = Pow;
			
			break;
		}
	}
}