#import "game_control.h"
#import "game_tower.h"
#import "game_enemy.h"
#import "game_common.h"

CControl g_Control;

void CControl::Init()
{
	m_TowerTex[0]=me_CreateTexture(@"tower_gun.png");
	m_TowerTex[1]=me_CreateTexture(@"tower_missile.png");
	m_TowerTex[2]=me_CreateTexture(@"tower_plasma.png");
	
	m_TowerBGTex=me_CreateTexture(@"tower_bg.png");
	
	m_CurrentMode=0;
}

void CControl::Render()
{
	if(m_CurrentMode==0)
	{
		me_PutSpr(341, 269, m_TowerBGTex);
		me_PutSpr(386, 269, m_TowerBGTex);
		me_PutSpr(430, 269, m_TowerBGTex);
	
		me_PutSpr(357, 285, m_TowerTex[0]);
		me_PutSpr(402, 285, m_TowerTex[1]);
		me_PutSpr(447, 285, m_TowerTex[2]);
	}
	else 
	{
		if(m_isEnable == 0) glColor4f(1, 0, 0, 1);
		me_PutSpr(m_TouchPos[0], m_TouchPos[1], m_TowerTex[m_SelectedTowerIndex-1]);
		glColor4f(1, 1, 1, 1);
	}
}

void CControl::TouchBegin(float x, float y)
{
	m_SelectedTowerIndex = 0;
	
	m_TouchStartPos[0]=x;
	m_TouchStartPos[1]=y;
	
	if(x >= 357 && x <= 389 && y >= 285 && y <= 317)
	{
		m_SelectedTowerIndex = TW_GUN;
	}
	
	if(x >= 402 && x <= 434 && y >= 285 && y <= 317)
	{
		m_SelectedTowerIndex = TW_MISSILE;
	}
	
	if(x >= 447 && x <= 479 && y >= 285 && y <= 317)
	{
		m_SelectedTowerIndex = TW_PLASMA;
	}
}

void CControl::TouchMove(float x, float y)
{
	if(m_SelectedTowerIndex == 0) return;
	
	m_TouchPos[0]=(int)(x / 32) * 32;
	m_TouchPos[1]=(int)(y / 32 - 1) * 32;
	
	vector2f delta={m_TouchStartPos[0]-x, m_TouchStartPos[1]-y};
	
	if( vec2length(delta)>16)
	{
		m_CurrentMode = 1;
	}
	
	if(m_CurrentMode)
	{
		int needMoney =0;
		switch (m_SelectedTowerIndex)
		{
			case TW_GUN: needMoney = 5; break;
			case TW_PLASMA: needMoney = 10; break;
			case TW_MISSILE: needMoney = 30; break;
		}
		
		if (g_Money < needMoney)
		{
			m_isEnable = 0;
			return;
		}
		
		int create = g_Tower.Create(m_TouchPos[0]/32, m_TouchPos[1]/32, m_SelectedTowerIndex);
		
		int PathIndexX[150], PathIndexY[150], PathIndexCount;
		if(g_Tower.PathFind(0, 4, 14, 4, 
							PathIndexX, PathIndexY, PathIndexCount)==YES)
			m_isEnable = 1;
		else 
			m_isEnable = 0;
		
		if(create)
		{
			g_Tower.Delete(m_TouchPos[0]/32, m_TouchPos[1]/32);
		}

	}
}

void CControl::TouchEnd(float x, float y)
{
	if(m_SelectedTowerIndex == 0) return;
	if(m_CurrentMode == 0) return;
	if(m_isEnable)
	{
		switch (m_SelectedTowerIndex)
		{
			case TW_GUN: g_Money -= 5; break;
			case TW_PLASMA: g_Money -= 10; break;
			case TW_MISSILE: g_Money -= 30; break;
		}
		
		g_Tower.Create(x/32, y/32-1, m_SelectedTowerIndex);
		g_Enemy.FindPathAgain();
	}
	
	m_CurrentMode=0;
	m_SelectedTowerIndex=0;
}