#pragma once
//#import <Cocoa/Cocoa.h>
#import <UIKit/UIKit.h>

#import "me_math.h"
#import "me_Sprite.h"
 

enum 
{
	ET_NONE,
	ET_SOLDIER,
	ET_CAR,
	ET_TANK,
	ET_MAX
};

struct SEnemy
{
	int Type;
	int HP;
	float Speed;
	vector2f Pos;
	vector2f TargetPos;
	float Angle;
	
	float WaitTime;

	int CurPathIndex;
	int PathIndexCount;
	int PathIndexX[150];
	int PathIndexY[150];
};

#define MAX_ENEMY 64
class CEnemy
{
protected:
	SEnemy m_Enemy[MAX_ENEMY];
	
	me_STexture m_EnemyTex[ET_MAX];
	
public:
	void Init();
	void Create(int Type, int HP, float Speed, float WaitTime);
	void FrameMove();
	void Render();
	
	void FindPathAgain();
	
	SEnemy *GetEnemy(int Index) { return &m_Enemy[Index]; }
	
	int Search(vector2f Pos, float radius);
	void SplashDamage(vector2f Pos, float radius, int Pow, int Except);
	
	int Empty();
};

extern CEnemy g_Enemy;