#pragma once
//#import <Cocoa/Cocoa.h>
#import <UIKit/UIKit.h>

#import "me_Sprite.h"

#define PF_NONE			0
#define PF_OPEN_NODE	1
#define PF_CLOSE_NODE	2

#define PF_RESULT_OK	0
#define PF_RESULT_NOWAY	1
#define PF_RESULT_NEXT	2

enum 
{
	TW_NONE,
	TW_GUN,
	TW_MISSILE,
	TW_PLASMA,
	TW_MAX
};

struct STower
{
	int Type;
	float Angle;
	
	int TargetIndex;
	
	float Pow;
	float FireDelay;
	float CurFireDelay;
	float Radius;
	
	STower()
	{
		Type = TW_NONE;
	}
};

struct SPFNode
{
	int Type;
	int F, G, H;
	
	int ParentX, ParentY;
	
	SPFNode()
	{
		Type = PF_NONE;
	}
};

class CTower
{
protected:
	STower m_TowerMap[10][15];
	
	me_STexture m_TowerTex[TW_MAX];
	
	SPFNode m_Node[10][15];
	
	int m_StartPosX, m_StartPosY, m_EndPosX, m_EndPosY;
	
public:
	void Init();
	void Render();
	void FrameMove();
	int Create(int x, int y, int Type);
	void Delete(int x, int y);
	
	int PathFind(int sx, int sy, int ex, int ey, int *PathIndexX, int *PathIndexY, int &PathIndexCount);
	int PathFindAndOpenNode2CloseNode();
	void FindAroundOpenNode(int CloseNodeX, int CloseNodeY);
};

extern CTower g_Tower;