//
//  Texture.h
//  SkyAtWar
//
//  Created by 영호 천 on 09. 06. 05.
//  Copyright 2009 ... All rights reserved.
//
#pragma once
//#import <Cocoa/Cocoa.h>
#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#include "me_math.h"
#include "me_Sprite.h"

#define MAX_PARTICLE 512
struct me_SParticle
{
	vector2f Pos;   
	vector2f PosDelta;
	vector2f PosAccel;	
	
	float Angle;
	float AngleDelta;
	
	float Scale;
	float ScaleDelta;
	
	vector4f Color;
	vector4f ColorDelta;
	
	float Life;
	
	me_STexture Tex;
	
	me_SParticle() { Life = 0.0f; }
};

class me_CParticleDataMgr
{
protected:
	me_SParticle ParticleData[MAX_PARTICLE];
		
public:
	void Add(me_SParticle Data);
		
	void Render();
};

extern me_CParticleDataMgr g_ParticleDataMgr;

class me_CParticle
{
protected:
	vector2f m_PosMin, m_PosMax;	
	vector2f m_PosDeltaMin, m_PosDeltaMax;			
	vector2f m_PosAccel;			
	
	float m_AngleMax, m_AngleMin;	
	float m_AngleDelta;
	
	float m_ScaleMax, m_ScaleMin;
	float m_ScaleDelta;
	
	vector4f m_Color;
	vector4f m_ColorDelta;
	
	float m_LifeMax, m_LifeMin;
	
	int m_CreateCount;
	float m_Delay;
	float m_CurrentDelay;
	
	me_STexture m_Tex;
	
public:
	void Load(const char *filename);
	
	void Process(vector2f Pos);
	
	void Release();
	
	me_CParticle();
	~me_CParticle();
};